module MusicMetaFixer
  class Song
    attr_accessor :name, :artist, :location, :genre, :album, :year

    def initialize name
      @name = name
    end

    def compare_to(another_song)
      diff = []
      self.instance_variables.each do |key|
        key = key.to_s.delete("@").to_sym
        diff += [key] unless another_song.send(key) == self.send(key)
      end
      diff
    end

    def pretty_string
      "Artist: #{artist}\n" \
      "Song: #{name}\n" \
      "Genre: #{genre}\n" \
      "Album: #{album}\n" \
      "Year: #{year}"
    end
  end
end
